{                                                                        }
{  Las clasicas interferencias.                                          }
{                                                                        }
{       Code based in Moderato Interf. Dec 94 by Crom & Mitra / SLORDS  }
{                                                                        }
{    V i S i T    t H e    S p A n I s H    d E m O s C e N e    W e B   }
{                     http://www.ergos.es/demos                          }
{                                                                        }
{                                                                        }
UNIT Interf;
INTERFACE
PROCEDURE MakeInterferences;

IMPLEMENTATION

Uses Mcga,Lib3DFP,Crt;

Var
  OldMode  : Byte;
  P3DScr   : Pointer;
  Mem3DScr : dword;
  OffWrite : word;
  OffStart : word;

Procedure  GenerateRings(Where:dword);
Var
  Radio    : Real;
  Angulo   : Real;
  IncAng   : Real;
  X,Y      : Integer;
  Pinta    : Boolean;
  CntPinta : Integer;

Begin
  Radio   :=     5;
  CntPinta:=     0;
  Pinta   := False;
  Repeat
    Angulo:=0;
    IncAng:=(1/Radio)-(1/(3*Radio));
    If Pinta Then
      Repeat
        X:=Round(160+(Radio*Cos(Angulo)));
        Y:=Round(100+(0.8*Radio*Sin(Angulo)));
        If ((X>=0) and (Y>=0) and (X<319) and (Y<199)) then Begin
                                                              Mem[0:where+(Y*320)+X]:=round(Radio);
                                                              Mem[0:where+(Y*320)+X+1]:=round(Radio); { Buggy holes :-( }
                                                            End;
        Angulo:=Angulo+IncAng;
      Until Angulo>=2*Pi;
    Inc (CntPinta);
    If CntPinta=5 Then
      Begin
        CntPinta:=0;
        If Pinta Then Pinta:=False
                 Else Pinta:=True;
      End;
    Radio:=Radio+1;
  Until Radio>180;
End;


Procedure MakePalette(Green:Byte);
Var
  CntCol : Byte;
  AuxCol : Byte;
  Up     : Boolean;
Begin
  CntCol :=   1;
  Up     :=True;
  AuxCol :=  24;
  PutColor (0,0,0,0);
  Repeat
    PutColor (CntCol,0,Green,AuxCol);
    If Up Then Begin
                 Inc (AuxCol);
                 If  AuxCol=63 Then Up:=False;
               End
          Else Begin
                 Dec (AuxCol);
                 If  AuxCol=24 Then Up:=True;
               End;
    Inc (CntCol);
  Until CntCol=0;
end;

Procedure Interferencias;
  Var
    IniX1,IniY1 : dword;
    IniX2,IniY2 : dword;
    Aux         : integer;
    Ang1        : integer;
    Ang2        : integer;
    CntColor    : Byte;
    Up          : Boolean;

  Procedure Put80x50Buffer (X,Y:dword);assembler;
    Asm
      mov  ebx,[X]
      mov  edx,[Y]
      xor  edi,edi
      mov  di ,[OffWrite]
      add  edi,0A0000h

      xchg dh,dl
      mov  esi,edx
      shr  esi,1
      shr  esi,1
      add  esi,edx
      add  esi,ebx
      add  esi,Mem3DScr
      mov  edx,50      { CntY = 50 bytes. }
    @OtraLinea:
      mov  ebx,80      { CntX = 80 bytes. }
    @OtroPixel:
      mov  al,[esi]
      cmp  al,0
      jz   @NoPoner
      mov  ah,[edi] { Any Pix? }
      cmp  ah,0
      je   @Nada
      xor  al,al
    @Nada:
      mov  [edi],al
    @NoPoner:
      inc  esi
      inc  edi
      dec  ebx
      jnz  @OtroPixel
      add  esi,240
      dec  edx
      jnz  @OtraLinea
    End;

  Begin
    OffWrite:=    0;
    OffStart:= 4000;
    Ang1    :=    0;
    Ang2    :=   68;
    CntColor:=    0;
    Up      := True;
    Repeat
      MakePalette   (CntColor);
      If Up then Begin
                   Inc (CntColor);
                   If CntColor=63 then Up:=False;
                 End
            else Begin
                   Dec (CntColor);
                   If CntColor=1 then Up:=True;
                 End;
      Aux:=80*FastCos(Ang1);asm sar [Aux],8 end;
      IniX1:=160+Aux;
      Aux:= 50*FastSin(Ang1);asm sar [Aux],8 end;
      IniY1:=100+Aux;
      Inc (Ang1,4);
      If Ang1>=1024 then Ang1:=Ang1-1024;
      Put80x50Buffer (IniX1,IniY1);

      Aux  := 80*FastCos(Ang2);asm sar [Aux],8 end;
      IniX2:=160+Aux;
      Aux  := 50*FastSin(Ang2);asm sar [Aux],8 end;
      IniY2:=100+Aux;
      Inc (Ang2,2);
      If Ang2>=1024 then Ang2:=Ang2-1024;
      Put80x50Buffer (IniX2,IniY2);

      If OffWrite=0 then Begin
                           OffWrite:=4000;
                           OffStart:=0;
                         End
                    else Begin
                           OffWrite:=0;
                           OffStart:=4000;
                         End;
      ChangeVGAOff  (OffStart);
      FillBytes     ($A0000+OffWrite,4000,0);
     Until keypress;
  End;

PROCEDURE MakeInterferences;
begin
  GetMem (P3DScr,64000);
  Mem3DScr := Ofs (P3DScr^);
  Fill64K       (Mem3DScr,0);
  WriteLn ;
  WriteLn ('Generating rings. Please wait ...');
  WriteLn ('Future Crew makes it, too. -:)');
  GenerateRings (Mem3DScr);
  VGA80x50;
  MakePalette(0);
  Interferencias;
  FreeMem (P3DScr,64000);
  McgaOff;
end;
END.